Subject: [webfinger] Additional comments on WebFinger draft

From: James M Snell <[email-masked]>
Date: Tue, 18 Dec 2012 12:22:34 -0800

Now that we seem to finally be past the HTTP/HTTPS discussion, some
additional non-HTTPS related feedback for the draft...

1. Section 5.2.1 [1]

It would be better to define the date-time stamp by referencing RFC3339 or
ISO 8601. Those are familiar references. Also, the way things are defined
in 5.2.1 currently, it would appear that numeric timezone offsets are not
permitted.. which seems wrong and unintentional. See RFC 4287 for an
example of how it should be done.

[1] http://tools.ietf.org/html/draft-ietf-appsawg-webfinger-07#section-5.2.1

2. Section 5.2.5.4 [2]

Rather than using simple language tags for the title labels, consider using
RFC4647 Language Ranges. Then, instead of defining a special "default" key
value, you can use the wildcard range "*" as the default. The difference is
subtle but good. For instasnce,

{
  "*": "This is the default",
  "en-*": "This matches all English-language variants",
  "fr-*": "This matches all Fresh-language variants",
  "en-UK": "This matches only UK English"
}

It's just a better model.

[2]
http://tools.ietf.org/html/draft-ietf-appsawg-webfinger-07#section-5.2.5.4

3. Right now the properties object is completely arbitrary. The key names
are supposed to be absolute IRI's but no guidance is given at all on how
those keys are to be selected and how they are to be used. Is there going
to be a registry model? Do people just throw whatever they want in there
and hope for the best? What kind of interop issues can we potential expect?
It would likely be good to flesh out that detail just a little.

4. Currently, both the resource parameter and subject property values are
not strictly limited to absolute URIs. Relative URI paths are permitted. I
believe that's an error.

- James

---

From: "Paul E. Jones" <[email-masked]>
Date: Wed, 19 Dec 2012 02:37:57 -0500

James,

Comments inline:

From: [email-masked] [mailto:[email-masked]] On Behalf Of James M Snell
Sent: Tuesday, December 18, 2012 3:23 PM
To: [email-masked]
Subject: [webfinger] Additional comments on WebFinger draft

Now that we seem to finally be past the HTTP/HTTPS discussion, some additional non-HTTPS related feedback for the draft...

1. Section 5.2.1 [1]

It would be better to define the date-time stamp by referencing RFC3339 or ISO 8601. Those are familiar references. Also, the way things are defined in 5.2.1 currently, it would appear that numeric timezone offsets are not permitted.. which seems wrong and unintentional. See RFC 4287 for an example of how it should be done.

PEJ: OK on using the RFC.  However, I do not want to allow fractional seconds or time zones, since that is disallowed in XRD and, consequentially, in RFC 6415 where JRD was defined.  I don’t want to break compatibility in the data format.

2. Section 5.2.5.4 [2]

Rather than using simple language tags for the title labels, consider using RFC4647 Language Ranges. Then, instead of defining a special "default" key value, you can use the wildcard range "*" as the default. The difference is subtle but good. For instasnce, 

{

}

[2] http://tools.ietf.org/html/draft-ietf-appsawg-webfinger-07#section-5.2.5.4

PEJ: I think we might also be constrained on the language definition, too.  The word “default” is defined to mean “*”.  We don’t even need “en-*”, because that’s the same as “en”.  So, I don’t want to change the reference.

3. Right now the properties object is completely arbitrary. The key names are supposed to be absolute IRI's but no guidance is given at all on how those keys are to be selected and how they are to be used. Is there going to be a registry model? Do people just throw whatever they want in there and hope for the best? What kind of interop issues can we potential expect? It would likely be good to flesh out that detail just a little.

PEJ: I have use for this, though you are correct that it’s not defined.  Just as we need to define WF-specific link relations, we need to define some properties.  One property that I want to define is “name” – a friendly name that identifies the subject.  For example:

“http://www.ietf.org/ns/name” : “James M. Snell”

Are there any examples in IETF specs that use namespace URIs like this?  In any case, I don’t want to define them right now, but that is something I’d like to do as a follow-up to this document.  For the moment, people can throw in whatever they want, much like the many link relations that have been unofficially adopted thus far under the webfinger.net domain.

4. Currently, both the resource parameter and subject property values are not strictly limited to absolute URIs. Relative URI paths are permitted. I believe that's an error.

PEJ: These must be absolute per: http://docs.oasis-open.org/xri/xrd/v1.0/xrd-1.0.html#element.subject

Paul

- James